config/routes.rb
Rails.application.routes.draw do

  namespace :admin do
    resources :bookings
  end
	root to: 'home#index'
	resources :bookings
  get '/donwload_invoice', controller: 'bookings', action: 'donwload_invoice'
	get '/admin/reports', controller: 'admin/bookings', action: 'reports', as: :admin_reports
  # devise_for :users
  Rails.application.routes.draw do
    devise_for :users, controllers: {
      sessions: 'users/sessions'
    }
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/booking.rb
class Booking < ApplicationRecord
	belongs_to :show
	belongs_to :movie
	belongs_to :customer , :class_name => 'User'
	has_many :booked_seats

	def total_amount
		self.booked_seats.map{|booked_seat|booked_seat.seat.row.screen.price}.sum
	end
	
end

app/controllers/admin/bookings_controller.rb
class Admin::BookingsController < ApplicationController
  before_action :authenticate_user!

  def index
	@bookings = Booking.order('created_at desc').includes(:show, :movie, :customer, {:booked_seats => {:seat => {:row => :screen}} })
  end
  
  def reports
  	if params[:date].present?
  		date = params[:date].to_date
  		@bookings = Booking.where('booking_for_date = ?', date).order('created_at desc').includes(:show, :movie, :customer, {:booked_seats => {:seat => {:row => :screen}} })
  	end
  end
end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_movie, only: [:index, :create]

  def index
    if params[:step] == '2'
      @shows = @movie.shows.where(date: params[:date].to_date)
      @screens = Theatre.last.screens.order('price ASC').includes(:rows => :seats)
      get_available_seats
    else
      @shows = @movie.shows.group_by{|e|e.date}
    end
    respond_to do |format|
      format.html
      format.js
    end
  end
  
  def get_available_seats
    booking_date = params[:date].to_date
    time_slot_id = params[:ts_id]
    show = @movie.shows.where(time_slot_id: params[:ts_id], date: params[:date].to_date).last
    @bookings = Booking.where(movie_id: @movie.id, booking_for_date: booking_date, show_id: show.id).includes(:movie, :booked_seats)
    @booked_seats = []
    if @bookings.present?
      @bookings.each do |booking|
        booking.booked_seats.each do |seat|
          @booked_seats << seat.seat_id
        end
      end
    end
  end

  def new

  end

  def create
    if check_valid_booking
      show = @movie.shows.where(time_slot_id: params[:time_slot_id], date: params[:booking_for_date].to_date).last
      @booking = Booking.create(
                      movie_id: @movie.id,
                      show_id: show.id,
                      booking_for_date: params[:booking_for_date].to_date,
                      customer_id: current_user.id,
                    )
      params[:seat_numbers].split(',').each do |seat_id|
        @booking.booked_seats.create(seat_id: seat_id)
      end
    else
      @cant_book = true
      @err_msg = "Sorry can't book, some of the seats just got booked. Please choose other seats."
    end  
    respond_to do |format|
      format.js
    end
  end

  def show
    @booking = Booking.find(params[:id])
    @movie = @booking.movie
  end

  def check_valid_booking
    true
  end

  def edit

  end

  def update

  end

  def destroy

  end

  def donwload_invoice
    @booking = Booking.find(params[:id])
    @movie = @booking.movie
    respond_to do |format|
      format.html
      format.pdf do
       render pdf: "#{@movie.name.downcase}-invoice",
       template: "bookings/invoice.pdf.erb",
       :disposition => 'attachment',
       layout: nil
     end
    end
  end

  private

  def set_movie
    @movie = Movie.find(params[:id])
  end

end

app/helpers/admin/bookings_helper.rb
module Admin::BookingsHelper
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/views/bookings/_available_seats.html.erb
<div class="row margin-top-20px text-center">
	<div class="col-md-10">
		<strong><h3>SCREEN - All Eyes This Way Please</h3></strong>
	</div>
</div>
<div class="row margin-top-20px">
	<div class="col-md-10">
		<% @screens.each do |screen| %>
			<div class="row text-center margin-top-20px margin-bottom-10px">
				<div class="col-md-12">
					<strong > <%= screen.name %> (Rs. <%= screen.price %>) </strong>
				</div>
			</div>
			<% screen.rows.each do |row| %>
				<div class="row margin-bottom-10px">
					<div class="col-md-1">
						<strong > <%= row.row_no %> </strong>
					</div>
					<% row.seats.each do |seat| %>
						<div class="col-md-1">
							<% if @booked_seats.include?(seat.id) %>
								<div class="occupied-seat-no occupied-seat" id="<%= seat.id %>"> <%= seat.seat_no %> </div>
							<% else %>
								<div class="seat-no-wrapper seat-no" id="<%= seat.id %>"> <%= seat.seat_no %> </div>
								<!-- <div class="price">Rs.<%#= seat.price %> <%#= seat.seat_type.name %></div> -->
							<% end %>
						</div>
					<% end %>
				</div>
			<% end %>
		<% end %>
	</div>
	<div class="col-md-2">
		<div class="row">
			<div class="col-md-2 available-label">
			</div>
			<div class="col-md-10">
				Available
			</div>
		</div>
		<div class="row margin-top-20px">
			<div class="col-md-2 occupied-label">
			</div>
			<div class="col-md-10">
				Occupied
			</div>
		</div>
	</div>
</div>

<style type="text/css">
	.seat-no
</style>

app/views/bookings/_movie_card.html.erb
<div class="card">
  <div class="card">
    <div class="user-bg no-margin"> <img width="100%" alt="user"
        src="<%= @movie.banner.path.split('public').last rescue nil %>"> </div>
    <div class="card-body">
      <!-- .row -->
      <div class="row text-center m-t-10">
        <div class="col-md-12 border-bottom m-b-20 p-b-20">
          <h5 class="card-title"><strong>
              <%= @movie.name %>
            </strong></h5>
        </div>
        <div class="col-md-6 border-right">
          <strong>Last Release</strong>
          <p>Feb 3, 2021</p>
        </div>
        <div class="col-md-6"><strong>Directed By</strong>
          <p>
            <%= @movie.director %>
          </p>
        </div>
      </div>

    </div>
  </div>
</div>

app/views/bookings/_step_one.html.erb
<div class="row movie-details pt-5">
  <div class="col-lg-4">
    <%= render :partial => 'movie_card' %>
  </div>
  <div class="col-lg-8">
    <div class="card">
      <div class="card-body">
        <h3>Book your slot</h3>
        <div class="row">
          <nav class="full-width booking-selection">
            <div class="nav nav-tabs nav-fill" id="nav-tab" role="tablist">
              <% @shows.each_with_index do |show, index| %>
                <% klass=(index==0) ? 'active' : '' %>
                  <a class="nav-item nav-link <%= klass %>" id="nav-home-tab" data-toggle="tab" href="#nav-<%= index %>"
                    role="tab" aria-controls="nav-home" aria-selected="true">
                    <%= show[0].strftime('%a, %e %b') %>
                  </a>
                  <% end %>
            </div>
          </nav>
          <div class="tab-content py-3 px-3 px-sm-0 full-width" id="nav-tabContent">
            <% @shows.each_with_index do |show, index| %>
              <% klass=(index==0) ? 'show active' : '' %>
                <div class="tab-pane fade <%= klass %>" id="nav-<%= index %>" role="tabpanel"
                  aria-labelledby="nav-home-tab">
                  <% show[1].each do |objekt| %>
                    <div class="time_slot" id="<%= objekt.time_slot.id%>">
                      <%= objekt.time_slot.start_time %>
                    </div>
                    <% end %>
                </div>
                <% end %>
          </div>
          <div class="col-md-12 margin-top-20px">
            <strong>How many seats?</strong>
          </div>
          <div class="col-md-12 display-flex-vertical margin-top-10px">
            <% 10.times do |no_of_seats| %>
              <% klass=(no_of_seats==0) ? 'styled-element' : '' %>
                <div class="no_of_seats <%= klass %>">
                  <%= no_of_seats + 1 %>
                </div>
                <% end %>
          </div>

          <div class="col-md-12 margin-top-10px">
            <button type="button" class="btn btn-info select-seats">Let's Select Seats <i
                class="fa fa-arrow-right"></i></button>
          </div>
        </div>
        <hr>
        <h3>About the movie</h3>
        <p>Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. In enim justo, rhoncus ut, imperdiet a,
          venenatis vitae, justo. Nullam dictum felis eu pede mollis pretium. Integer tincidunt.Cras dapibus. Vivamus
          elementum semper nisi. Aenean vulputate eleifend tellus. Aenean leo ligula, porttitor eu, consequat vitae,
          eleifend ac, enim. </p>
        <p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the
          industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and
          scrambled it to make a type specimen book. It has survived not only five centuries It was popularised in the
          1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop
          publishing software like Aldus PageMaker including versions of Lorem Ipsum. Songs (Singles)</p>
        <h3>Star Cast</h3>
        <div class="row m-t-30 el-element-overlay">
          <!-- column -->
          <% @movie.star_casts.each do |key, val| %>
            <% val.each do |star|%>
              <div class="col-lg-2 col-md-3">
                <div class="el-card-item">
                  <div class="el-card-avatar el-overlay-1"> <img src="/assets/users/default_user.png" alt="user">

                  </div>
                  <div class="el-card-content text-left">
                    <h5 class="card-title m-b-0">
                      <%= star%>
                    </h5>
                  </div>
                </div>
              </div>
              <% end %>
                <% end %>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/bookings/_step_two.html.erb
<div class="row pt-5">
	<div class="col-12 white-box">
		<div class="row">
			<h2>Choose your seat</h2>
		</div>
		<div class="row">
			<div class="col-md-6">
				<strong ><%= params[:date] %> </strong>
			</div>
			<div class="col-md-6">
				<strong> <%= params[:no_of_seats]%> Tickets </strong>
			</div>
		</div>
		<div class="row margin-top-20px step-two">
			<div class="col-md-12 display-flex-vertical">
				<% @shows.each_with_index do |show, index| %>
					<% time_slot = show.time_slot %>
			<% klass = (show.time_slot_id.to_s == params[:ts_id]) ? 'active_time_slot' : '' %>
			<div class="time_slot <%= klass %>" id="<%= time_slot.id %>"> <%= time_slot.start_time %> </div>
		  <% end %>
			</div>
		</div>
		<div id="available_seats">
			<%= render :partial => 'available_seats' %>
		</div>
		<div class="row margin-top-20px margin-bottom-40px">
			<div class="col-md-12">
				<%= form_tag("/bookings", :method => "post", remote: true) do %>
					 <%= hidden_field_tag(:id, @movie.id) %>
					 <%= hidden_field_tag(:booking_for_date, params[:date]) %>
					 <%= hidden_field_tag(:time_slot_id) %>
					 <%= hidden_field_tag(:seat_numbers) %>
					 <%= submit_tag "Confirm My Booking", :class => 'btn btn-success confirm-my-booking', data: { disable_with: 'Processing! Please Wait'}%>
				<% end %>
			</div>
		</div>
	</div>
</div>

<script type="text/javascript">
	var no_of_seats = "<%= params[:no_of_seats] %>"
	$(document).on('click', '.seat-no-wrapper', function(event){
		$(this).toggleClass('selected-seat')
		var selected_seats_count = $('.selected-seat').length
		if(selected_seats_count == no_of_seats){
			$('.confirm-my-booking').show()
			$('html, body').animate({
        scrollTop: $(".confirm-my-booking").offset().top
    	}, 500);$('#booking_for_date').val()
			$('#time_slot_id').val($('.time_slot.active_time_slot').attr('id').trim())
			var arr = []
			$( ".selected-seat" ).each(function( index ) {
				arr.push($(this).attr('id'))
			});
			$('#seat_numbers').val(arr.join(','))
		}
		else if(selected_seats_count > no_of_seats){
			$('.seat-no').removeClass('selected-seat')	
			$(this).toggleClass('selected-seat')
			if(no_of_seats != 1){
				$('.confirm-my-booking').hide()
			}
		} 
		else{
			$('.confirm-my-booking').hide()
			$('.seat-no').addClass('seat-no-wrapper')
		}
	})
</script>

app/views/bookings/create.html.erb
<h1>Bookings#create</h1>
<p>Find me in app/views/bookings/create.html.erb</p>

app/views/bookings/create.js.erb
<% if @err_msg.present? %>
	
<% else %>
	window.location.href = "/bookings/<%= @booking.id %>?s=1" 
<% end %>

app/views/bookings/destroy.html.erb
<h1>Bookings#destroy</h1>
<p>Find me in app/views/bookings/destroy.html.erb</p>

app/views/bookings/edit.html.erb
<h1>Bookings#edit</h1>
<p>Find me in app/views/bookings/edit.html.erb</p>

app/views/bookings/index.html.erb
<% if params[:step] == '2' %>
	<%= render :partial => 'step_two' %>
<% else %>
	<%= render :partial => 'step_one' %>
<% end %>  

<script type="text/javascript">

	$(function () {
		$('.nav-link').unbind('click').bind('click', function(e){
			$(".nav-link").removeClass('active');
			$(this).addClass('active');
			$(`#nav-tabContent .tab-pane`).removeClass('show active');
			$(`#nav-tabContent .tab-pane${$(this).attr("href")}`).addClass('show active');
			$('.time_slot').removeClass('active_time_slot')
		})

		$('.select-seats').unbind('click').bind('click', function(){
			date = $('.nav-link.active').text()
			time_slot_id = $('.active_time_slot').attr('id')
			no_of_seats = $('.styled-element').text() 
			if(time_slot_id == undefined){
				alert('Please select time slot')
				return true
			}
			id = "<%= params[:id] %>"
			window.location.href = '/bookings?step=2&date=' + date + '&ts_id=' + time_slot_id + '&no_of_seats=' + no_of_seats + '&id=' + id
		})

		$('.time_slot').unbind('click').bind('click', function(){
			$('.time_slot').removeClass('active_time_slot')
			$(this).addClass('active_time_slot')
		})


		$('.step-two .time_slot').unbind('click').bind('click', function(){
			$('.time_slot').removeClass('active_time_slot')
			$(this).addClass('active_time_slot')
			$(".loader-full-page").removeClass('hide')
			$(".confirm-my-booking").hide()
			$.ajax({
			  type: "GET", 
			  url: "/bookings",
			  dataType: "script",
			  data: {slot_selection: true, 	step: 2, id: "<%= @movie.id %>", date: "<%= params[:date] %>", ts_id: $('.active_time_slot').attr('id')}
			})
		})

		$('.no_of_seats').unbind('click').bind('click', function(){
			$('.no_of_seats').removeClass('styled-element')
			$(this).addClass('styled-element')
		})

		
	})
</script>

app/views/bookings/index.js.erb
$('#available_seats').html("<%= j render(:partial => 'available_seats') %>");
$(".loader-full-page").addClass('hide')

app/views/bookings/invoice.pdf.erb
<%= stylesheet_link_tag wicked_pdf_asset_base64("application.css"), :media => "all" %>
<%= javascript_include_tag "http://code.jquery.com/jquery-1.10.0.min.js" %>
<%= javascript_include_tag "http://code.jquery.com/ui/1.10.3/jquery-ui.min.js" %>
<div class="row margin-top-20px">
  <div class="col-md-12">
    Scan below QR code at entry
  </div>
</div>
<div class="row margin-top-20px">
  <div class="col-md-12">
    <div class="qr-png">
      <% @img = get_qr_code %>
      <img src="<%= @img.to_data_url %>" alt="Red dot" style="height: 140px; width: 140px;">
    </div>
  </div>
</div>
<div class="row margin-top-20px">
  <div class="col-md-12">
    <table class="table">
      <tbody>
        <tr>
          <td>Movie Name</td>
          <td><strong><%= @movie.name.titleize%></strong></td>
        </tr>
        <tr>
          <td>Show Date</td>
          <td><strong><%= @booking.booking_for_date %></strong></td>
        </tr>
        <tr>
          <td>Show Timing</td>
          <td><strong><%= @booking.show.time_slot.start_time %></strong></td>
        </tr>
        <tr>
          <td>Seats Booked</td>
          <td>
            <strong>
              <% objects = @booking.booked_seats.includes(:seat => {:row => :screen}) %>
              <% objects.each_with_index do |booked_seat, index| %>  
                <% seat = booked_seat.seat %>
                <% row = seat.row %>
                <% screen = row.screen %>
                <% str = '' %>
                <% str = str +  "#{screen.name}  | #{row.row_no} | #{seat.seat_no}" %> 
                <% if index > 0 and index != (objects.count + 1) %>
                  <% str = str + ', ' %>
                <% end %>
                <%= str %>
              <% end %>
            </strong>
          </td>
        </tr>
        <tr>
          <td>Total Amount</td>
          <td><strong>Rs.<%= @booking.total_amount %></strong></td>
        </tr>
      </tbody>
    </table>
  </div>
</div>

<div class="row margin-top-20px">
  <div class="col-md-12">
    Thank You!
  </div>
</div>

app/views/bookings/new.html.erb
<h1>Bookings#new</h1>
<p>Find me in app/views/bookings/new.html.erb</p>

app/views/bookings/show.html.erb
<div class="row movie-details pt-5">
  <div class="col-lg-4">
    
    <%= render :partial => 'movie_card' %>
  </div>
  <div class="col-lg-8">
    <div class="card">
      <div class="card-body">
        <% if params[:s].present? %>
            <div class="alert alert-success margin-top-20px" role="alert">
            Movie Ticked Booked Successfully!
            </div>
        <% end %>
        <h4> Booking <strong>#<%= @booking.id %></strong></h4>
        <div class="table-responsive">
            <table class="table">
                <tbody>
                    <tr>
                        <td>Movie Name</td>
                        <td><strong><%= @movie.name.titleize%></strong></td>
                        
                    </tr>
                    <tr>
                        <td>Show Date</td>
                        <td><strong><%= @booking.booking_for_date %></strong></td>
                        
                    </tr>
                    <tr>
                        <td>Show Timing</td>
                        <td><strong><%= @booking.show.time_slot.start_time %></strong></td>
                        
                    </tr>
                    <tr>
                        <td>Total Amount</td>
                        <td><strong>Rs.<%= @booking.total_amount %></strong></td>
                    </tr>
                    
                </tbody>
            </table>
            
            <%= link_to 'Download Invoice', donwload_invoice_path(id: @booking.id, format: :pdf), :class => 'btn btn-primary' %>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/bookings/update.html.erb
<h1>Bookings#update</h1>
<p>Find me in app/views/bookings/update.html.erb</p>